'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _childProcess = require('./childProcess');

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CodePushCli = function () {
  function CodePushCli(binaryPath) {
    _classCallCheck(this, CodePushCli);

    this._binaryPath = binaryPath;
  }

  _createClass(CodePushCli, [{
    key: 'releaseReact',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(appName, platform, _ref2) {
        var targetBinaryVersion = _ref2.targetBinaryVersion,
            mandatory = _ref2.mandatory,
            deploymentName = _ref2.deploymentName,
            rolloutPercentage = _ref2.rolloutPercentage,
            askForConfirmation = _ref2.askForConfirmation;

        var codePushCommand, shouldExecuteCodePushCommand, _ref3, userConfirmedCodePushCommand;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                codePushCommand = `${this.binaryPath} release-react \
${appName} \
${platform} \
${targetBinaryVersion ? `-t ${targetBinaryVersion}` : ''} \
${mandatory ? `-m` : ''} \
${deploymentName ? `-d ${deploymentName}` : ''} \
${rolloutPercentage ? `-r ${rolloutPercentage}` : ''} \
${platform === 'ios' ? `-b MiniApp.jsbundle` : ''}`;
                shouldExecuteCodePushCommand = true;

                if (!askForConfirmation) {
                  _context.next = 9;
                  break;
                }

                log.info(`Will run:\n${codePushCommand}`);
                _context.next = 6;
                return _inquirer2.default.prompt({
                  type: 'confirm',
                  name: 'userConfirmedCodePushCommand',
                  message: 'Do you confirm code push command execution ?',
                  default: true
                });

              case 6:
                _ref3 = _context.sent;
                userConfirmedCodePushCommand = _ref3.userConfirmedCodePushCommand;

                shouldExecuteCodePushCommand = userConfirmedCodePushCommand;

              case 9:
                if (!shouldExecuteCodePushCommand) {
                  _context.next = 12;
                  break;
                }

                _context.next = 12;
                return (0, _childProcess.execp)(codePushCommand);

              case 12:
                return _context.abrupt('return', shouldExecuteCodePushCommand);

              case 13:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function releaseReact(_x, _x2, _x3) {
        return _ref.apply(this, arguments);
      }

      return releaseReact;
    }()
  }, {
    key: 'binaryPath',
    get: function get() {
      return this._binaryPath ? this._binaryPath : `code-push`;
    }
  }]);

  return CodePushCli;
}();

exports.default = CodePushCli;
//# sourceMappingURL=CodePushCli.js.map