"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var FILE_PATH_RE = /^file:(.+)/;
var GIT_PATH_RE = /^git(.+)/;

var DependencyPath = function () {
  function DependencyPath(path) {
    _classCallCheck(this, DependencyPath);

    this.path = path;
  }

  _createClass(DependencyPath, [{
    key: "toString",
    value: function toString() {
      return this.path;
    }
  }, {
    key: "isAFileSystemPath",
    get: function get() {
      return FILE_PATH_RE.test(this.path);
    }
  }, {
    key: "isAGitPath",
    get: function get() {
      return GIT_PATH_RE.test(this.path);
    }
  }, {
    key: "unprefixedPath",
    get: function get() {
      var result = this.path;
      if (this.isAFileSystemPath) {
        result = FILE_PATH_RE.exec(this.path)[1];
      } else if (this.isAGitPath) {
        result = GIT_PATH_RE.exec(this.path)[1];
      }
      return result;
    }
  }], [{
    key: "fromString",
    value: function fromString(strPath) {
      return new DependencyPath(strPath);
    }
  }, {
    key: "fromFileSystemPath",
    value: function fromFileSystemPath(fsPath) {
      return new DependencyPath(`file:${fsPath}`);
    }
  }]);

  return DependencyPath;
}();

exports.default = DependencyPath;
//# sourceMappingURL=DependencyPath.js.map