'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fileUtil = require('./fileUtil');

var fileUtils = _interopRequireWildcard(_fileUtil);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _shell = require('./shell');

var _shell2 = _interopRequireDefault(_shell);

var _spin = require('./spin');

var _spin2 = _interopRequireDefault(_spin);

var _tmp = require('tmp');

var _tmp2 = _interopRequireDefault(_tmp);

var _childProcess = require('./childProcess');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var fetch = require('node-fetch');

var ReactNativeCli = function () {
  function ReactNativeCli(binaryPath) {
    _classCallCheck(this, ReactNativeCli);

    this._binaryPath = binaryPath;
  }

  _createClass(ReactNativeCli, [{
    key: 'init',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(appName, rnVersion) {
        var dir;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                dir = _path2.default.join(process.cwd(), appName);

                if (!_fs2.default.existsSync(dir)) {
                  _context.next = 3;
                  break;
                }

                throw new Error(`Path already exists will not override ${dir}`);

              case 3:
                return _context.abrupt('return', (0, _childProcess.execp)(`${this.binaryPath} init ${appName} --version react-native@${rnVersion} --skip-jest`));

              case 4:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function init(_x, _x2) {
        return _ref.apply(this, arguments);
      }

      return init;
    }()
  }, {
    key: 'bundle',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref3) {
        var entryFile = _ref3.entryFile,
            dev = _ref3.dev,
            bundleOutput = _ref3.bundleOutput,
            assetsDest = _ref3.assetsDest,
            platform = _ref3.platform;
        var bundleCommand;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                bundleCommand = `${this.binaryPath} bundle \
${entryFile ? `--entry-file=${entryFile}` : ''} \
${dev ? '--dev=true' : '--dev=false'} \
${platform ? `--platform=${platform}` : ''} \
${bundleOutput ? `--bundle-output=${bundleOutput}` : ''} \
${assetsDest ? `--assets-dest=${assetsDest}` : ''}`;
                return _context2.abrupt('return', (0, _childProcess.execp)(bundleCommand));

              case 2:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function bundle(_x3) {
        return _ref2.apply(this, arguments);
      }

      return bundle;
    }()
  }, {
    key: 'startPackager',
    value: function startPackager(cwd) {
      (0, _childProcess.spawnp)(this.binaryPath, ['start'], { cwd });
    }
  }, {
    key: 'startPackagerInNewWindow',
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(cwd) {
        var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
        var isPackagerRunning;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.isPackagerRunning();

              case 2:
                isPackagerRunning = _context3.sent;

                if (isPackagerRunning) {
                  _context3.next = 17;
                  break;
                }

                _context3.next = 6;
                return (0, _spin2.default)('Starting React Native packager', Promise.resolve());

              case 6:
                if (!(process.platform === 'darwin')) {
                  _context3.next = 10;
                  break;
                }

                return _context3.abrupt('return', this.darwinStartPackagerInNewWindow({ cwd, args }));

              case 10:
                if (!/^win/.test(process.platform)) {
                  _context3.next = 14;
                  break;
                }

                return _context3.abrupt('return', this.windowsStartPackagerInNewWindow({ cwd, args }));

              case 14:
                throw new Error(`${process.platform} is not supported yet`);

              case 15:
                _context3.next = 18;
                break;

              case 17:
                log.warn('A React Native Packager is already running in a different process');

              case 18:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function startPackagerInNewWindow(_x4) {
        return _ref4.apply(this, arguments);
      }

      return startPackagerInNewWindow;
    }()
  }, {
    key: 'darwinStartPackagerInNewWindow',
    value: function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(_ref6) {
        var _ref6$cwd = _ref6.cwd,
            cwd = _ref6$cwd === undefined ? process.cwd() : _ref6$cwd,
            _ref6$args = _ref6.args,
            args = _ref6$args === undefined ? [] : _ref6$args;
        var tmpDir, tmpScriptPath;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                tmpDir = _tmp2.default.dirSync({ unsafeCleanup: true }).name;
                tmpScriptPath = _path2.default.join(tmpDir, 'packager.sh');
                _context4.next = 4;
                return fileUtils.writeFile(tmpScriptPath, `
cd "${cwd}"; 
echo "Running ${this.binaryPath} start ${args.join(' ')}";
${this.binaryPath} start ${args.join(' ')};
`);

              case 4:
                _shell2.default.chmod('+x', tmpScriptPath);
                (0, _childProcess.spawnp)('open', ['-a', 'Terminal', tmpScriptPath]);

              case 6:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function darwinStartPackagerInNewWindow(_x6) {
        return _ref5.apply(this, arguments);
      }

      return darwinStartPackagerInNewWindow;
    }()
  }, {
    key: 'windowsStartPackagerInNewWindow',
    value: function () {
      var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(_ref8) {
        var _ref8$cwd = _ref8.cwd,
            cwd = _ref8$cwd === undefined ? process.cwd() : _ref8$cwd,
            _ref8$args = _ref8.args,
            args = _ref8$args === undefined ? [] : _ref8$args;
        var tmpDir, tmpScriptPath;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                tmpDir = _tmp2.default.dirSync({ unsafeCleanup: true }).name;
                tmpScriptPath = _path2.default.join(tmpDir, 'packager.bat');
                _context5.next = 4;
                return fileUtils.writeFile(tmpScriptPath, `
cd "${cwd}"; 
echo "Running ${this.binaryPath} start ${args.join(' ')}";
${this.binaryPath} start ${args.join(' ')};
`);

              case 4:
                _shell2.default.chmod('+x', tmpScriptPath);
                (0, _childProcess.spawnp)('cmd.exe', ['/C', tmpScriptPath], { detached: true });

              case 6:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function windowsStartPackagerInNewWindow(_x7) {
        return _ref7.apply(this, arguments);
      }

      return windowsStartPackagerInNewWindow;
    }()
  }, {
    key: 'isPackagerRunning',
    value: function () {
      var _ref9 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                return _context6.abrupt('return', fetch('http://localhost:8081/status').then(function (res) {
                  return res.text().then(function (body) {
                    return body === 'packager-status:running';
                  });
                }, function () {
                  return false;
                }));

              case 1:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function isPackagerRunning() {
        return _ref9.apply(this, arguments);
      }

      return isPackagerRunning;
    }()
  }, {
    key: 'binaryPath',
    get: function get() {
      return this._binaryPath ? this._binaryPath : 'react-native';
    }
  }]);

  return ReactNativeCli;
}();

exports.default = ReactNativeCli;
//# sourceMappingURL=ReactNativeCli.js.map