'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tmp = require('tmp');

var _tmp2 = _interopRequireDefault(_tmp);

var _shell = require('./shell');

var _shell2 = _interopRequireDefault(_shell);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _DependencyPath = require('./DependencyPath');

var _DependencyPath2 = _interopRequireDefault(_DependencyPath);

var _childProcess = require('./childProcess');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var YarnCli = function () {
  function YarnCli(binaryPath) {
    _classCallCheck(this, YarnCli);

    this._binaryPath = binaryPath;
  }

  _createClass(YarnCli, [{
    key: 'add',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(dependencyPath) {
        var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
            dev = _ref2.dev,
            peer = _ref2.peer;

        var tmpDirPath, cmd;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // Special handling with yarn add when the dependency is a local file path
                // In that case, for some reason it copies the node_modules directory of this path, which
                // is not a wanted behavior, especially for react-native bundling as it will create
                // haste module naming collisions
                // As a temporaray work-around, we copy the whole package directory to a temporary one
                // and remove node_modules from there and use this new path instead when yarn adding
                // Issue has been opened here https://github.com/yarnpkg/yarn/issues/1334
                // (still open as of this comment writing)
                // [Note: We tried another lighter workaround being to just remove the node_modules
                // directory contained within this package after yarn add is executed. Howver subsequent
                // yarn add of a different dependency just reintroduce the error on previous package
                // this is really weird]
                if (dependencyPath.isAFileSystemPath) {
                  tmpDirPath = _tmp2.default.dirSync({ unsafeCleanup: true }).name;

                  _shell2.default.cp('-R', `${/file:(.+)/.exec(dependencyPath.toString())[1]}/*`, tmpDirPath);
                  _shell2.default.rm('-rf', _path2.default.join(tmpDirPath, 'node_modules'));
                  dependencyPath = _DependencyPath2.default.fromFileSystemPath(tmpDirPath);
                }

                cmd = `add ${dependencyPath.toString()} --ignore-engines --exact ${dev ? '--dev' : ''} ${peer ? '--peer' : ''}`;
                return _context.abrupt('return', this.runYarnCommand(cmd));

              case 3:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function add(_x) {
        return _ref.apply(this, arguments);
      }

      return add;
    }()
  }, {
    key: 'install',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        var cmd;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                cmd = `install --ignore-engines`;
                return _context2.abrupt('return', this.runYarnCommand(cmd));

              case 2:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function install() {
        return _ref3.apply(this, arguments);
      }

      return install;
    }()
  }, {
    key: 'upgrade',
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(dependencyPath) {
        var cmd;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                cmd = `upgrade ${dependencyPath.toString()} --ignore-engines --exact`;
                return _context3.abrupt('return', this.runYarnCommand(cmd));

              case 2:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function upgrade(_x3) {
        return _ref4.apply(this, arguments);
      }

      return upgrade;
    }()
  }, {
    key: 'init',
    value: function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        var cmd;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                cmd = `init --yes`;
                return _context4.abrupt('return', this.runYarnCommand(cmd));

              case 2:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function init() {
        return _ref5.apply(this, arguments);
      }

      return init;
    }()
  }, {
    key: 'info',
    value: function () {
      var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(dependencyPath) {
        var _ref7 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
            field = _ref7.field,
            json = _ref7.json;

        var packageJsonPath, cmd, output;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                if (!dependencyPath.isAFileSystemPath) {
                  _context5.next = 6;
                  break;
                }

                packageJsonPath = _path2.default.join(dependencyPath.toString().substr(5), `package.json`);

                log.debug(`[runYarnCommand] Running info: returning ${packageJsonPath} `);
                return _context5.abrupt('return', JSON.parse(_fs2.default.readFileSync(packageJsonPath, `utf-8`)));

              case 6:
                cmd = `info ${dependencyPath.toString()} ${field || ''} ${json ? '--json' : ''}`;
                _context5.next = 9;
                return this.runYarnCommand(cmd);

              case 9:
                output = _context5.sent;
                return _context5.abrupt('return', JSON.parse(output.toString()));

              case 11:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function info(_x4) {
        return _ref6.apply(this, arguments);
      }

      return info;
    }()
  }, {
    key: 'runYarnCommand',
    value: function () {
      var _ref8 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(command) {
        var cmd;
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                cmd = `${this.binaryPath} ${command}`;

                log.debug(`[runYarnCommand] Running ${cmd}`);
                return _context6.abrupt('return', (0, _childProcess.execp)(cmd));

              case 3:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function runYarnCommand(_x6) {
        return _ref8.apply(this, arguments);
      }

      return runYarnCommand;
    }()
  }, {
    key: 'binaryPath',
    get: function get() {
      return this._binaryPath ? this._binaryPath : `yarn`;
    }
  }]);

  return YarnCli;
}();

exports.default = YarnCli;
//# sourceMappingURL=YarnCli.js.map