'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.writeFile = exports.writeJSON = exports.readJSON = exports.readFile = undefined;

/**
 * ==============================================================================
 * Async wrappers around node fs
 * ==============================================================================
 */
var readFile = exports.readFile = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(filename) {
    var encoding = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'utf8';
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt('return', new Promise(function (resolve, reject) {
              _fs2.default.readFile(filename, encoding, function (err, res) {
                if (err) reject(err);else resolve(res);
              });
            }));

          case 1:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function readFile(_x) {
    return _ref.apply(this, arguments);
  };
}();

var readJSON = exports.readJSON = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(filename) {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            return _context2.abrupt('return', readFile(filename).then(JSON.parse));

          case 1:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function readJSON(_x3) {
    return _ref2.apply(this, arguments);
  };
}();

var writeJSON = exports.writeJSON = function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(filename, json) {
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt('return', writeFile(filename, JSON.stringify(json, null, 2)));

          case 1:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function writeJSON(_x4, _x5) {
    return _ref3.apply(this, arguments);
  };
}();

var writeFile = exports.writeFile = function () {
  var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(filename, data) {
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            return _context4.abrupt('return', new Promise(function (resolve, reject) {
              _fs2.default.writeFile(filename, data, function (err, res) {
                if (err) reject(err);else resolve(res);
              });
            }));

          case 1:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function writeFile(_x6, _x7) {
    return _ref4.apply(this, arguments);
  };
}();

/**
 * Recursively apply file mode for a given path
 * @param fileMode
 * @param path
 */


exports.chmodr = chmodr;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _ernUtil = require('ern-util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function chmodr(fileMode, path) {
  _ernUtil.shell.chmod('-R', fileMode, path);
}
//# sourceMappingURL=fileUtil.js.map